QGIS Application - Bug report #7472
vector editing errors
2013-03-29 04:02 AM - Alessandro Ciali

Status: Closed

Priority: Severe/Regression

Assignee:

Category: Digitising

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corruptsdata: Copied to github as #: 16425
Description

With the current night-build release 1.9.0-134 editing an existing feature (I try node tool, clip and rotate feature) reports the follow warning
in the log window (OGR):

Already active iterator on this provider was closed (level 1)

For polygon shapefile layer editing ends ok.
For line shapefile layer after editing all the features except the one edited disappear; saving changes restores the features.

It seems to be related to bug #7321 and bug #7267. This bug causes serious problems during editing.
The warnings were added in commit:ec07a0c2.

Related issues:

Related to QGIS Application - Bug report # 7321: all feature disappear when a... Closed 2013-03-11
Related to QGIS Application - Bug report # 7267: loss of attributes during sp... Closed 2013-03-03
Related to QGIS Application - Bug report # 7071: Field calculator regression ... Closed 2013-01-29
Related to QGIS Application - Bug report # 7862: "Already active iterator on ... Closed 2013-05-19
Related to QGIS Application - Bug report # 7668: Merge feature tools causes Q... Closed 2013-04-22
Related to QGIS Application - Bug report # 8317: Deleted features are not rea... Closed 2013-07-17
Duplicated by QGIS Application - Bug report # 7660: all features disappear wh... Closed 2013-04-20

Associated revisions

Revision 4164d6ed - 2013-06-21 04:19 PM - Nathan Woodrow

Merge branch 'iterator’

Semi fix #7472.

Semi fix #7862

Revision 810c11bb - 2013-07-16 03:53 PM - Jiirgen Fischer

ogr provider: move REPACK into createSpatiallndex. Don't REPACK in deleteFeatures as there might still be pending changes that depend on the current

feature ids (fixes #7472)

History

#1 - 2013-04-23 02:23 AM - Jiirgen Fischer

See also http://lists.osgeo.org/pipermail/qgis-developer/2013-April/025320.html ff
http://lists.osgeo.org/pipermail/qgis-developer/2013-April/025320.html

#2 - 2013-05-26 04:22 PM - Larry Shaffer

- File 7472 _1_before-edit.png added

- File 7472_2_on-edit_before-save.png added
- File 7472_3_edit-saved.png added

Just ran into this nasty bug today, on Mac with recent master build of commit:5e28220. Makes simple editing seem destructive. Attached are photos

showing the features disappearing during editing.

Provider: Spatialite

Layer type: Point
Map tool: Move feature (moved feature with 'trailhead' symbol)

Not sure if it is related, but after about 5 minutes of editing, and upon clicking 'Save edits' button, the associated CPU spins up to 100% and it takes a long

time to save the edits, about 1-3 minutes. If | don't quit the app, the wait for saving or toggling editing gets even longer.

#3 - 2013-05-28 09:02 PM - Nathan Woodrow

- Assignee set to Martin Dobias

#4 - 2013-05-30 01:31 PM - Sandro Santilli

- Operating System changed from window to window, GNU/Linux

Same problem here with PostGIS provider on GNU/Linux.

#5 - 2013-05-31 12:34 AM - Jiirgen Fischer

- Operating System deleted (window, GNU/Linux)
- OS version deleted (win7 64bit)

#6 - 2013-06-21 07:23 AM - Anonymous

- Status changed from Open to Closed

Fixed in changeset commit:"4164d6ed0b8498f3e3e45cfa40b639674c8c5074".

#7 - 2013-06-21 07:25 AM - Nathan Woodrow

This should be fixed now with the ogr provider. The PostGIS and spatialite driver are yet to be done.

#8 - 2013-06-22 01:46 AM - Alessandro Ciali

| have just tested version commit:f8d6e32 and it seems to perform editing in a right way! I've tested all the editing tools like add, copy-cut-paste, move,
rotate, reshape,node tool on a polygon shapefile and always works perfectly. By the way | will continue to perform tests. Even the noise with features

disappearing during editing with categorized rendered layers seems to be resolved.

#9 - 2013-06-22 03:30 AM - Giovanni Manghi
- Status changed from Closed to In Progress

Nathan Woodrow wrote:

The PostGIS and spatialite driver are yet to be done.

so better tag this as "in progress"?

#10 - 2013-06-23 01:56 AM - Nathan Woodrow
- Assignee deleted (Martin Dobias)

- Status changed from In Progress to Closed

- Resolution set to fixed

All the other providers are done now.

#11 - 2013-06-27 12:55 AM - Alessandro Ciali
- Status changed from Closed to Reopened

| reopen this bug because it seems that editing is still affected by the seriouos problems already described. | performed some editing tasks, on a new
created polygon shape: add new features, delete features and cut existing ones. After saving some features disappear and other are duplicated getting the
attribute of the disappeared ones. This problem occurs with high frequency but is not systematic, so | can reproduce it, but not every time | perform an
editing operation. It happens after saving, so it corrupts the shape permanently.

Tested on win7 with last master.

#12 - 2013-06-27 12:56 AM - Giovanni Manghi

- Crashes QGIS or corrupts data changed from No to Yes
- Category changed from Vectors to Digitising

- Resolution deleted (fixed)

#13 - 2013-07-09 06:24 AM - Nathan Woodrow

- Status changed from Reopened to Closed

Alessandro, can you do some more testing for us using a new version of master. | can't replicate any data loss or incorrect behavior. There was some

issues with the split tools that have been fixed recently so | think this might have been caused by them.

I'm going to close this for now. Reopen if you still see the issue and can reproduce it for us.

#14 - 2013-07-10 01:40 AM - Alessandro Ciali

I nathan, at this moment | have commit:d37e03b version on win7, that's the most recent version | can download with OSGEO4W, so | think it's better to
wait for a newer commit.

I'll post a ticket as soon as possible about results of tests,

bye
#15 - 2013-07-14 02:32 PM - Alessandro Ciali
- File test19edit.zip added

It seems that the problems with editing still persist. | have made some tests, and found a bug, reproducible almost every time you make the following
actions:

- start editing the shape

- draw a feature, delete one feature, add another one;

save: after saving a feature disappear, and another has been duplicated with the attribute of the disappeared feature.
| attached the shape and project used in test.

Other tools (split, merge, merge attribute) seems to work as expected.

I hope it will help to get rid of this bug,

#16 - 2013-07-15 01:35 AM - Giovanni Manghi

Alessandro Ciali wrote:

It seems that the problems with editing still persist. | have made some tests, and found a bug, reproducible almost every time you make the following
actions:

- start editing the shape

- draw a feature, delete one feature, add another one;

save: after saving a feature disappear, and another has been duplicated with the attribute of the disappeared feature.

| attached the shape and project used in test.

Hi Alessandro,
this sound really similar to #8274
the point is that in both cases we are struggling to replicate the issue.
| used your project, and done the described steps, but still no issue.
Would you mind do and attach a screencast? You can use this
no installation needed.
#17 - 2013-07-15 02:33 PM - Alessandro Ciali
- File edit_bug.avi added
Hi giovanni,
| made an orrible video, but | hope enough to show the problem. | summarize the actions:
- create polygon !#32
- delete polygon !#0
- create polygon !#33

- save edits

polygons #25 and |#33 disappear and polygons #23 and !#28 are duplicated. The error may occur after a variable number of attemps. | think that the
problem arises when the command "delete feature" is used after or before a command that create a new feature during. As you can se | work in windows
http://www.screencast-o-matic.com/

7. Reopen the ticket if you can replicate it.

I'm here if you have other requests, bye

#18 - 2013-07-16 01:13 AM - Giovanni Manghi
- Status changed from Closed to Reopened

Alessandro Ciali wrote:
Hi giovanni,
I made an orrible video, but | hope enough to show the problem. | summarize the actions: - create polygon #32
- delete polygon 1#0
- create polygon #33
- save edits

Hi Alessandro, I'm finally able to replicate it.

#19 - 2013-07-16 01:22 AM - Giovanni Manghi
- File 12.png added
- File 46.png added

Hi Alessandro, I'm finally able to replicate it.

attached screenshots before and after.

If you will use the project attached by Alessandro please ignore the missing layer error, and be sure to enable the "avoid intersection” option in the
snapping dialog. Put also some transparency to the layer.

https://issues.qgis.org/attachments/6000/test19edit.zip

#20 - 2013-07-16 06:54 AM - Jiirgen Fischer
- Status changed from Reopened to Closed

Fixed in changeset commit:"810c11bb60a4c7d9959778159ce10af2effd9458".

#21 - 2014-01-19 06:28 AM - Simon Dedman

- Status changed from Closed to Reopened

Hi all, apologies for reopening if this isn't the best way of raising this.

I've just posted this problem on gis.stackexchange here, after having a similar problem here, and | think they're related to this bug.

In brief: in QGis master, csv files (and polygons e.g. voronoi built off them?) disappear when styles other than 'single symbol' are selected. A blank-named
column field is present at the end of the list of candidate columns upon which to base the style.
https://issues.qgis.org/attachments/6000/test19edit.zip
https://gis.stackexchange.com/questions/83522/graduated-colouring-voronoi-polygons-qgis
https://gis.stackexchange.com/questions/72284/why-are-some-values-missing-from-the-imported-csv

In DuFour, neither of these problems are present.

Thanks. Let me know if this is unrelated to the internal workings of this page's bug and i'll open a new bug report for it.

Simon

#22 - 2014-01-20 01:54 PM - Giovanni Manghi
- Status changed from Reopened to Closed

- Resolution set to fixed/implemented

Simon Dedman wrote:

Hi all, apologies for reopening if this isn't the best way of raising this.

In DuFour, neither of these problems are present.

Simon

I've just posted this problem on gis.stackexchange here, after having a similar problem here, and | think they're related to this bug.

blank-named column field is present at the end of the list of candidate columns upon which to base the style.

Thanks. Let me know if this is unrelated to the internal workings of this page's bug and i'll open a new bug report for it.

In brief: in QGis master, csv files (and polygons e.g. voronoi built off them?) disappear when styles other than 'single symbol' are selected. A

| can't see how the issue you describe is related to the description of this ticket. Please file a new ticket with a proper (resumed) description, and steps/data

to replicate. Thanks!

Files

7472_1_before-edit.png 260 KB 2013-05-26 Larry Shaffer
